SystemOrganization addCategory: #'RecentSubmissions-Core'!
SystemOrganization addCategory: #'RecentSubmissions-UI'!

MorphTreeNodeModel subclass: #MessageListAbstractNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListAbstractNode commentStamp: '<historical>' prior: 0!
A MessageListAbstractNode is an abstract node model.
Instance Variables
!

!MessageListAbstractNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
changeStyler: aTextArea

	self useDefaultStyler: aTextArea.
	aTextArea styler classOrMetaClass: self getClass! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
doubleClick

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
environment

	self model 
		ifNotNilDo: [:each | ^each environment].
	self error: 'The model should probably not be nil'! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
getClass

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
includes: aNode
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
inspectableContents
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
isInspectable

	^self subclassResponsibility
! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
isMethod

	^ self item isMethod.! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
originalIndex

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
printList: aStream

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
removeMe
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
useDefaultStyler: aTextArea

	self environment
		at: #SHTextStylerST80 
		ifPresent: [ :stylerClass | aTextArea styler: (stylerClass new view: aTextArea) ]
		ifAbsent: [ aTextArea styler: ( NullTextStyler new view: aTextArea) ]! !

MessageListAbstractNode subclass: #MessageListInspectableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListInspectableNode methodsFor: 'comparing' stamp: ''!
= anotherNode

	anotherNode species = self species
		ifTrue: [^ self item = anotherNode item]
		ifFalse: [^ false].! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
doubleClick

	self item browse! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: ''!
getClass

	^self item actualClass! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: ''!
includes: aNode

	^ self = aNode complexContents.! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
inspectableContents

	^ OrderedCollection new add: self; yourself.! !

!MessageListInspectableNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
isInspectable

	^true! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: ''!
originalIndex

	^self model originalIndex: (self item)! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:40'!
printList: aStream
	
	aStream nextPutAll: self item classSymbol asString;
		nextPutAll: ' >> ';
		nextPutAll: self item selector.! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 10:25'!
removeMe

	self model model removeMethodReference: self item.
	self model emptyTheSelection.! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
rowMorphForColumn: aTreeColumn

	^ self item ifNotNil: [:i | self item printStringForRML asString asMorph] ! !

MessageListAbstractNode subclass: #MessageListNonInspectableNode
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListNonInspectableNode methodsFor: 'comparing' stamp: ''!
= anotherNode

	anotherNode species = self species
		ifTrue: [^ self item = anotherNode item]
		ifFalse: [^ false].! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
childNodeClassFromItem: anItem

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^MessageListInspectableNode].
			self model level = 3
				ifTrue:[^self class]]
		ifFalse: [^MessageListInspectableNode]
! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: ''!
childrenItems

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^self dictionary at: self item].
			self model level = 3
				ifTrue:[^self dictionary  keys]]
		ifFalse: [^self dictionary at: self item]

! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
dictionary

	dictionary ifNil: [
		self parentNode isNil
			ifTrue:  [
				self model level = 2
					ifTrue: [dictionary := self model dictionary].
				self model level = 3
					ifTrue:[dictionary := self model dictionary at: self item]]
			ifFalse: [dictionary := self model dictionary at: (self parentNode item)]].
	^dictionary! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
doubleClick

	| class |
	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[class := self getClass].
			self model level = 3
				ifTrue:[class := (self childNodeFromItem: (self childrenItems first)) getClass]]
		ifFalse: [
			class := self getClass].
		ToolSet browse: class selector: nil
	! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
getClass

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^self item].
			self model level = 3
				ifTrue:[^self error: 'You shouldn''t ask the class of a package']]
		ifFalse: [^self item]! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: ''!
includes: aNode

	^ (self = aNode complexContents) | ((self contents 
												detect: [:each |each includes: aNode]
												ifNone: [nil]) notNil)! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
inspectableContents

	| result |
	result := OrderedCollection new.
	
	self contents do: [:each | result addAll: each inspectableContents].
	^ result.! !

!MessageListNonInspectableNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
isInspectable

	^false! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
originalIndex

	| methodReference |
	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue: [methodReference := (self childrenItems first)].
			self model level = 3
				ifTrue: [ methodReference := (self dictionary associations first value first).]]
		ifFalse: [
			methodReference := (self childrenItems first)].
	^self model originalIndex: methodReference
	! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
printList: aStream

	| tab |
	tab := '- '.
	aStream 
		nextPutAll: self item asString;
		nextPutAll: ' :'.
	self contents do: [:each | 
			aStream nextPutAll: '
'.
			aStream nextPutAll: tab.
			each printList: aStream]
! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: ''!
removeMe

	self contents do: [:each | each removeMe].! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
rowMorphForColumn: aTreeColumn

	self item ifNotNil: [:i | 
			self level = 1
				ifTrue: [
					self model level = 2 
						ifTrue: [^self item name asString asMorph].
					self model level = 3
						ifTrue: [	^self item asString asMorph]]
				ifFalse: [ ^self item name asString asMorph]]! !

MorphTreeMorph subclass: #MessageListTreeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListTreeMorph commentStamp: '<historical>' prior: 0!
MessageListTreeMorph is the class representing the visualisation tree.!

!MessageListTreeMorph methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
allInspectableNodes
	"Answer all the inspectables nodes of the tree"
	
	| result |
	result := OrderedCollection new.
	self roots do: [:each | result addAll: each complexContents inspectableContents].
	^ result contents.! !

!MessageListTreeMorph methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:24'!
collapseAll

	self roots do: [:each|
		each isExpanded 
			ifTrue:[
				each toggleExpandedState.
				each owner owner adjustSubmorphPositions]].
	self model selectedMorph: nil.! !

!MessageListTreeMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/2/2010 13:41'!
includes: aNode

	^(self roots 
			detect:  [:each | each complexContents includes: aNode]
			ifNone: [nil]) notNil! !

!MessageListTreeMorph methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
mouseUp: event onMorph: aNodeMorph

	| path selHolder cmdOrCtrl |
	cmdOrCtrl := self commandOrCrontrolKeyPressed: event.
	"self selectionChanged."
	path := event shiftPressed 
		ifTrue: [self shiftSelectMorph: aNodeMorph]
		ifFalse: [self selectMorph: aNodeMorph multiple: (cmdOrCtrl or: [self autoMultiSelection])].
	selHolder := self newSelectionHolderWithNodePath: path.
	self emptySelectionSilently.
	model perform: self setSelectionSelector with: selHolder.
	self highlightSelection.
	Cursor normal show ! !

!MessageListTreeMorph methodsFor: 'selection' stamp: ''!
nodeMorphsWithAllNodeItems: aNodeItem
	"In this case, aNodeItemList always contains a single element"

	aNodeItem isEmpty ifTrue: [ ^ aNodeItem].
	^ self allNodeMorphs select: [:m | m complexContents withoutListWrapper == aNodeItem first]! !

!MessageListTreeMorph methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
selectionChanged
	"Transcript show: 'selectionChanged';cr."
	
	self model selectedMorph: self selectedMorph.! !

!MessageListTreeMorph methodsFor: 'selection' stamp: ''!
selectionColorToUse: aColor
	"Set the colour for selected items"

	aColor = self selectionColorToUse ifTrue: [^self].
	aColor
		ifNil: [self removeProperty: #selectionColorToUse]
		ifNotNil: [self setProperty: #selectionColorToUse toValue: aColor].! !

!MessageListTreeMorph methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 11/29/2010 11:19'!
setSelectedNodeItemList: aNodeItemCollection
	"Modified to remove the update signal"
	
	| keptSelectedMorphList |
	self model textArea canDiscardEdits
				ifFalse:[self model promptForCancel
						ifTrue:  [self model textArea hasUnacceptedEdits: false]
						ifFalse: [
							self selectMorph: (self model selectedMorph) multiple: false.
							self highlightSelection.
							^self]].	
	self selectedMorphList removeAll.
	"Don't work directly with selectedMorphList because for very long list, #drawOn: is time consuming"
	keptSelectedMorphList  := selectedMorphList.
	selectedMorphList := OrderedCollection new "#(). if you break here, you can't restart the code due to the removeAll 4 lines above".
	keptSelectedMorphList  addAll: (self nodeMorphsWithAllNodeItems: aNodeItemCollection).
	selectedMorphList := keptSelectedMorphList.
	lastClickedMorph ifNil: [lastClickedMorph :=  selectedMorphList ifEmpty: [nil] ifNotEmpty: [selectedMorphList last]].
	self selectionChanged.! !

MorphTreeModel subclass: #MessageListBrowser
	instanceVariableNames: 'model selectedMorph treeMorph textArea preference window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListBrowser commentStamp: 'BenjaminVanRyseghem 8/31/2010 01:43' prior: 0!
MessageListBrowser is the UI for instances of MessageList

Instance Variables:
	messageList	<Object>
	dictionary	<BrowserEnvironment | Dictionary | OpenFileStreamRegistry | RBSmallDictionary | SharedPool class | SmallDictionary | SmalltalkImage | WeakRegistry>
	originalList	<ProtoObject | PseudoContext>
	selectedMorph	<Object>
	treeMorph	<MorphTreeMorph>
	textArea	<CodeMorph | OBPluggableTextMorphWithShout | PluggableShoutMorph | PluggableTextMorphPlus>
	dropList	<ProtoObject | PseudoContext>
	preference	<Object>
	sortingSelector	<ProtoObject | PseudoContext>!

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byClassOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byClassSelector! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byDateAscendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateAscendingSelector! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byDateDescendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateDescendingSelector.! !

!MessageListBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/29/2010 10:23'!
on: aMessageList
	^self new model: aMessageList
	! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
on: aMessageList groupedUsing: aSelector
	
	| association |
	association := (aMessageList perform: aSelector).
	^self new
		messageList: aMessageList;
		dictionary:  association key;
		originalList: association value.

	! !

!MessageListBrowser methodsFor: 'items addition' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
addAllItems: aWindow

	| width toolbar btnFont |	
	toolbar := self buildToolbar: aWindow.
	btnFont := StandardFonts buttonFont.
	aWindow
		addMorph: self treeMorph
		fullFrame: (LayoutFrame
			fractions: (0@0 corner: 1@0.5)
			offsets:(0@0 corner:0@0)).
	aWindow
		addMorph: toolbar
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@0.5)
			offsets:(0@0 corner:0@(btnFont height + 14))).
			
	self textArea: self buildTextArea.
	
	aWindow
		addMorph: self textArea
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@1)
			offsets:(0@(btnFont height + 14) corner:0@0)).! !

!MessageListBrowser methodsFor: 'items addition' stamp: ''!
addTextArea: aWindow

	aWindow 
		addMorph: self textArea 
		frame: (0@0.5 corner: 1@1).	! !

!MessageListBrowser methodsFor: 'items addition' stamp: ''!
addTree: aWindow

	aWindow 
		addMorph:  self treeMorph
		frame: (0@0 corner: 1@0.45).! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonAction 

	self browseSelectedMorph! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonLabel

	^'Browse'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonState 

	^self selectedMorph isNil.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
browseSelectedMorph

	self selectedMorph ifNotNilDo: [ :each | each complexContents doubleClick].! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonBrowse
	
	^(PluggableButtonMorph 
		on: self 
		getState: #browseButtonState 
		action: #browseButtonAction 
		label: #browseButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonClear
	
	^(PluggableButtonMorph 
		on: self 
		getState: #clearButtonState 
		action: #clearButtonAction 
		label: #clearButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonRemove
	
	^(PluggableButtonMorph 
		on: self 
		getState: #removeButtonState 
		action: #removeButtonAction 
		label: #removeButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
buildButtonRevert
	
	^(PluggableButtonMorph 
		on: self 
		getState: #revertButtonState 
		action: #revertButtonAction 
		label: #revertButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
buildDisplayDropList: aWindow

	^(UITheme current 
		newDropListIn: aWindow
		for:self				
		list: #getDisplayList
		getSelected: #sortingSelector
		setSelected: #sortingSelector:
		getEnabled: nil
		useIndex: false 
		help: self sortingSelectorHelpText) hResizing: #rigid; width: 150; yourself
! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/2/2010 15:17'!
buildPreferenceDropList: aWindow

	^(UITheme current 
		newDropListIn: aWindow
		for:self				
		list: #getPreferencesList
		getSelected: #preference
		setSelected: #preference:
		getEnabled: nil
		useIndex: false 
		help: self preferenceHelpText) hResizing: #rigid; width: 150; yourself! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
buildTextArea

	| text |
	text := PluggableTextMorph 
		on: self
		text: #textToDisplay
		accept: #compileMethod:
		readSelection: nil
		menu: #msgPaneMenu:shifted:.
	text 
		visible: false;
		askBeforeDiscardingEdits: true.
	^ text! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
buildToolbar: aWindow
	"create the buttons toolbar"
	
	| toolbar |
	toolbar := aWindow newToolbar: {
		self buildPreferenceDropList: aWindow.
		self buildDisplayDropList: aWindow.
		self buildButtonBrowse.
		self buildButtonRevert.
		self buildButtonRemove.
		self buildButtonClear}.
	^toolbar hResizing: #shrinkWrap! !

!MessageListBrowser methodsFor: 'items creation' stamp: ''!
buildTreeMorph

	self treeMorph: ((MessageListTreeMorph on: self)
				doubleClickSelector: #doubleClick;
				autoDeselection: true;
				autoMultiSelection: false;
				beSingle;
				rowInset: 4;
				columnInset: 4;
				getMenuSelector: #menu:shifted:;
				sortingSelector: #originalIndex;
				rowColorForEven: Color lightGray muchLighter odd: Color white).
	self treeMorph buildContents! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byClassLabel

	^'By Class'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byDateAscendingLabel

	^'By Date Ascending'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byDateDescendingLabel

	^'By Date Descending'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byPackageLabel

	^'By Package'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byVersionLabel

	^'By Version'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
byteCodeLabel

	^'Byte Code'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
clearButtonAction

	self promptForClear
		ifTrue: [self model clearAll]! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
clearButtonLabel

	^'Clear List'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
clearButtonState 

	^self dictionary isEmpty.! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 1/11/2011 16:38'!
compileMethod: aString

	| method class lastEntry |
	self textArea hasUnacceptedEdits: false.
	method := self 
				getMethod: (self selectedMorph complexContents)
				ifAbsent: ["use the information from the tree"
					class := self selectedMorph complexContents getClass.
					nil].
	method ifNotNil: [:m | class := m methodClass].
	class compile: (aString).
	self changed: #textToDisplay.
	self updateSelection.
	lastEntry := self lastEntry.
	self treeMorph selectMorph: lastEntry multiple: false.
	self selectedMorph: lastEntry.! !

!MessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
delete

	self window delete.! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
dictionary

	| result |
	result := self model dictionary.
	result ifEmpty: [self selectedMorph: nil].
	^result! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
diffLabel

	^'Diffs'! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
displayIfByteCode: aMessageListInspectableNode

	 | method |
	method := self getMethod: aMessageListInspectableNode ifAbsent: [nil].
	method ifNotNilDo: [ :each | ^each method symbolic ].
	^self unvailableByteCodeLabel! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
displayIfDiff: aMessageListInspectableNode

	| methodReference |
	methodReference := aMessageListInspectableNode item.
	^TextDiffBuilder
		 buildDisplayPatchFrom: ((self model priorVersionOfAMethod: methodReference) sourceCode) 
		to: (methodReference sourceCode) 
		inClass: (methodReference classSymbol)! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 1/20/2011 15:54'!
displayIfInfo: aMessageListInspectableNode

	^ 'Last modification : 
		', (aMessageListInspectableNode item timeStamp asDateAndTime asTimeStamp asString)
! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
displayIfSource: aMessageListInspectableNode

		aMessageListInspectableNode changeStyler: self textArea.
		^ aMessageListInspectableNode item sourceCode.! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
displayIfVersion: aMessageListInspectableNode

	^'Version ', (self model versionOfAMethod: aMessageListInspectableNode item) asString! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
displayInformationFrom: aMessageListInspectableNode

	self removeStyler.
	self preference = self sourceLabel
		ifTrue: [^ self displayIfSource: aMessageListInspectableNode].
	self preference = self byteCodeLabel
		ifTrue: [^ self displayIfByteCode: aMessageListInspectableNode].
	self preference = self infoLabel
		ifTrue: [	^ self displayIfInfo: aMessageListInspectableNode].
	self preference = self versionLabel
		ifTrue:[ ^self displayIfVersion: aMessageListInspectableNode].
	self preference = self diffLabel 
		ifTrue: [^ self displayIfDiff: aMessageListInspectableNode].
	^ self error: 'Error in the drop list'! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
doubleClick

	self selectedNode ifNotNil: [:n | n doubleClick]! !

!MessageListBrowser methodsFor: 'accessing' stamp: ''!
emptyTheSelection
	
	self selectedMorph: nil.! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
environment

	^ self model environment! !

!MessageListBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:45'!
format: aString

	| list size result |
	size := 0.
	list := aString subStrings: String cr.
	list do: [:line || addedCharacter tempSize|
		addedCharacter := ''.
		line first == $- ifTrue: [addedCharacter := '	'].
		tempSize := (addedCharacter, line) size.
		(tempSize > size) ifTrue: [size := tempSize]]! !

!MessageListBrowser methodsFor: 'droplist' stamp: ''!
getDisplayList

	^OrderedCollection new
		add: self byClassLabel;
		add: self byVersionLabel;
		add: self byDateAscendingLabel;
		add: self byDateDescendingLabel;
		add: self byPackageLabel;
		yourself.
! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
getMethod: aMessageListInspectableNode

	| methodReference |
	methodReference := (self getMethodReference: aMessageListInspectableNode) .
	^ methodReference compiledMethod.
	! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
getMethod: aMessageListInspectableNode ifAbsent: aBlock

	| methodReference |
	methodReference := (self getMethodReference: aMessageListInspectableNode) .
	^ methodReference actualClass methodDict
			at: methodReference selector
			ifAbsent: aBlock.
	! !

!MessageListBrowser methodsFor: 'tree' stamp: ''!
getMethodReference: aMessageListInspectableNode

	^aMessageListInspectableNode item.! !

!MessageListBrowser methodsFor: 'droplist' stamp: ''!
getPreferencesList

	^OrderedCollection new
		add: self sourceLabel;
		add: self byteCodeLabel;
		add: self diffLabel;
		add: self versionLabel;
		add: self infoLabel;
		yourself.
! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
infoLabel

	^'Change Date'! !

!MessageListBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
initialize

	self textArea: self buildTextArea.
	self preference: self getPreferencesList first.
! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
isComment

	| node |
	node := self selectedMorph complexContents.
	^(node isInspectable) & (node item = 'Comment'). ! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:23'!
lastEntry 

	| aNode |
	aNode :=  self treeMorph allInspectableNodes detect: [:each | each item = self model lastEntry] ifNone:[self error: 'Last enty not found'].
	^ self treeMorph nodeMorphOfNode: aNode.! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
level

	^ self model level.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
menu: menu shifted: b 

	menu
		add: 'Browse' translated
		target: self
		selector: #browseSelectedMorph.
	menu
		add: 'Remove'
		target: self
		selector: #removeSelectedMorph.
	menu
		add: 'Expand All'
		target: self treeMorph
		selector: #expandAll.
	menu
		add: 'Collapse All'
		target: self treeMorph
		selector: #collapseAll..
	^menu! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:22'!
model

	^model! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:22'!
model: aModel

	model := aModel.
	model
		when: #changed
		send: #updateView
		to: self.
	model
		when: #reset
		send: #delete
		to: self.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
msgPaneMenu: aMenu shifted: shifted

	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!MessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 1/11/2011 14:06'!
openInWorld

	self buildTreeMorph.	
	
	window := StandardWindow new model: self.
	window title: self model title.
	self addAllItems: window.
	window themeChanged.
	window openInWorld.
	^ window! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
originalIndex: aMethodeReference
	"must respect the original order because the dictionary is automaticaly sorted"

	| tempList |
	tempList := self originalList.
	
	1 to: (tempList size) do:[:i |
			(tempList at: i) == aMethodeReference
				ifTrue: [^i]].
	self error: 'Index not found'.
	^0! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
originalList

	^ self model sortedMethodReferencesList! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
preference

	^ preference! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/11/2011 16:39'!
preference: anObject

	preference := anObject.
	self changed: #textToDisplay.
	self updateSelection.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
preferenceHelpText

	^'Choose way to show'! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
promptForCancel
	"Ask if it is OK to cancel changes to text"
	
	^(self confirm:
'Changes have not been saved.
Is it OK to cancel those changes?' translated)
					
	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
promptForClear
	"Ask if it is OK to remove all the nodes"
	
	^(self confirm: 'Do you really want to clear the list ?' translated)
					
	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:46'!
promptForRemove: aNode
	"Ask if it is OK to remove the node"
	
	| list |
	
	list := WriteStream on: ''.
	list nextPutAll: 'Are you sure you want to remove :
'.
	aNode printList: list.
	list nextPutAll: ' ?'.
	self format: list contents.

	
	^(self confirm: list contents translated)
					
	! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
rebuildTree: aTree selection: aNode
	"rebuild the tree and keep the selection"

		aTree updateList.
		aNode ifNotNilDo: [:each | 
			(aTree includes: aNode)
				ifTrue: [
					aTree selectMorph: aNode multiple: false.
					self selectedMorph: aNode]]
		
		! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonAction 

	self removeSelectedMorph! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonLabel

	^'Remove'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonState 

	^self selectedMorph isNil.! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeSelectedMorph

	self selectedMorph ifNotNilDo: [:each | 
		(self promptForRemove: each complexContents)
			ifTrue:[each complexContents removeMe]]! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
removeStyler

	self textArea styler: ( NullTextStyler new view: self textArea)! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
revertButtonAction 

	(self revertButtonState not and: [self textArea hasUnacceptedEdits not])
		ifTrue: [self compileMethod: self textArea getText asString.]
		ifFalse: [ExampleBuilderMorph new alert: 'The source code must have not been modified']! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
revertButtonLabel

	^'Revert'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
revertButtonState 

	^self selectedMorph isNil
		ifTrue:[true]
		ifFalse:[self selectedMorph complexContents isInspectable not]! !

!MessageListBrowser methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:23'!
rootItems

	self model useAsASet
		ifTrue: [^ self originalList]
		ifFalse: [^self dictionary keys select: [:each | each isNil not]] "with some test, the class may be nil oO"
	! !

!MessageListBrowser methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
rootNodeClassFromItem: anItem
	"the class used to build node"
	
	^self model useAsASet 
		ifTrue:[MessageListInspectableNode]
		ifFalse: [MessageListNonInspectableNode]! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
selectedMorph

	^ selectedMorph! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/11/2011 16:39'!
selectedMorph: anObject

	| mustBeUpdate |
	mustBeUpdate := false.
	anObject = self selectedMorph
		ifFalse: [mustBeUpdate := true].
	mustBeUpdate
		ifTrue: [
			selectedMorph := anObject.
			self changed: #textToDisplay.
			self updateSelection.
			self updateTextArea].
	^ self.! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:40'!
sortingSelector

	self model isSortedByClass
		ifTrue: [	^ self byClassLabel].
	self model isSortedByDateAscending
		ifTrue: [	^ self byDateAscendingLabel].
	self model isSortedByDateDescending
		ifTrue: [	^ self byDateDescendingLabel].
	self model isSortedByPackage
		ifTrue: [	^ self byPackageLabel].
	self model isSortedByVersion
		ifTrue: [	^ self byVersionLabel].! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
sortingSelector: anObject

	anObject = self byClassLabel
		ifTrue: [	self model groupedByClass ].
	anObject = self byDateAscendingLabel
		ifTrue: [	self model groupedByDateAscending ].
	anObject = self byDateDescendingLabel
		ifTrue: [	self model groupedByDateDescending ].
	anObject = self byPackageLabel
		ifTrue: [	self model groupedByPackage ].
	anObject = self byVersionLabel
		ifTrue: [	self model groupedByVersion ].
	self updateView.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
sortingSelectorHelpText

	^'Set the way to sort items'
! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
sourceLabel

	^'Source'! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
textArea

	^ textArea! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
textArea: anObject

	textArea := anObject! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 1/11/2011 16:38'!
textToDisplay
	
	self selectedMorph isNil 
		ifFalse: [
			self selectedMorph complexContents isInspectable 
				ifTrue: [^self displayInformationFrom: self selectedMorph complexContents]].
	^nil! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
treeMorph

	^ treeMorph! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
treeMorph: anObject

	treeMorph := anObject! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
unvailableByteCodeLabel

	^'Byte code unavailable for this object'! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 1/11/2011 16:47'!
updateSelection

	| text interval |
	self model ifNotNil: [
		text := self textArea text asString.
		interval := self model autoSelectionInterval: text.
		self textArea setSelection: interval]! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 1/11/2011 16:32'!
updateTextArea

	(self selectedMorph isNil)
		ifTrue:  [self textArea visible: false]
		ifFalse: [
			(self selectedMorph complexContents isInspectable)
				ifTrue: [self textArea visible: true]
				ifFalse:[self textArea hide]]! !

!MessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
updateView

	| currentSelectedMorph association |
	self changed: #dictionary.
	self changed: #originalList.
	self model reSort.
	currentSelectedMorph := self selectedMorph.
	self treeMorph ifNotNilDo: [ :tree |
		self rebuildTree: tree selection: currentSelectedMorph].! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
versionLabel

	^'Version'! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
window

	^ window! !

Object subclass: #MessageList
	instanceVariableNames: 'methodReferenceList versionsHistoryList useAsASet lastEntry sortingSelector environment dictionary sortedMethodReferencesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

!MessageList commentStamp: 'BenjaminVanRyseghem 11/29/2010 11:31' prior: 0!
MessageList is a simple object that holds a set of ordered method definitions.
See MessageList example for an example.

MessageList example

Instance Variables:
	methodReferenceList	<Collection>!

!MessageList class methodsFor: 'example' stamp: 'StephaneDucasse 11/26/2010 17:14'!
example
	"self example"

	| oldSource newSource t1 t2 t3 ml mlb |
	oldSource := 'example1
	"This is the old version of the method"
	Transcript show: ''This is the old version of the method'' ;cr.'.

	newSource := 'example1
	"This is the new version of the method"
	Transcript show: ''This is the new version of the method'' ;cr.'.

	t1 := SourcedMethodReference new
			setStandardClass: MessageList class
			methodSymbol: #example.

	MessageList class compile: oldSource classified: 'example'.

	t2 := SourcedMethodReference new
		setStandardClass: MessageList class
		methodSymbol: #example1.
		
	"here you can modify MessageList >> initialize to see the difference"
	MessageList class compile: newSource classified: 'example'.
		
	t3 := SourcedMethodReference new
		setStandardClass: MessageList class
		methodSymbol: #example1.

	ml := MessageList new
			addMethodReference: t1;
			addMethodReference: t2;
			addMethodReference: t3.

	mlb := MessageListBrowser byClassOn: ml.

	mlb openInWorld! !

!MessageList class methodsFor: 'example' stamp: 'StephaneDucasse 11/26/2010 17:14'!
example1
	"This is the new version of the method"
	Transcript show: 'This is the new version of the method' ;cr.! !

!MessageList class methodsFor: 'instance creation' stamp: ''!
with: aCollection.

	^self new
		methodReferenceList: aCollection.! !

!MessageList methodsFor: 'actions' stamp: 'StephaneDucasse 11/26/2010 16:14'!
addFirstVersion

	| systemVersion date association |
	systemVersion := SystemVersion new date: 'Unknown'.
	date := TimeStamp new.
	association := Association key: systemVersion value: date.
	self versionsHistoryList add: association.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:29'!
addMethodReference: aMethodReference

	self addMethodReferenceSilently: aMethodReference.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:28'!
addMethodReferenceSilently: aMethodReference

	self useAsASet
		ifTrue: [ self methodReferenceList removeAllSuchThat: [:each | each stringVersion = aMethodReference stringVersion]].
	self checkCurrentHighestUpdate: aMethodReference.
	self methodReferenceList add: aMethodReference.
	lastEntry := aMethodReference.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
addVersion: anAssociation

	self versionsHistoryList add: anAssociation.
	self updateView! !

!MessageList methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 1/11/2011 16:22'!
autoSelectionInterval: aText

	^ 0 to: 0! !

!MessageList methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 11/29/2010 10:12'!
buildByClass
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| key value |
		key := each actualClass.
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
buildByDate: aBlock
	"Return an association where key is a Dictionary and value is the list sorted"

	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: aBlock.
	tempList do: [:each |
		| key1 key2 value |
		key1 := each date.
		key2 := each actualClass.
		value := each.		
		(result includesKey: key1)
			ifFalse: [result at: key1 put: Dictionary new].
		((result at: key1) includesKey: key2)
			ifFalse: [(result at: key1) at: key2 put: OrderedCollection new].
		((result at: key1) at: key2) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
buildByPackage
	"Return an association where key is a Dictionary and value is the list sorted"

	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| class key1 key2 value |
		class := self environment detect: [:g | g name asSymbol = each classSymbol].
		key1 := class category.
		key2 := each actualClass.
		value := each.
			
		(result includesKey: key1)
			ifFalse: [result at: key1 put: Dictionary new].
		((result at: key1) includesKey: key2)
			ifFalse: [(result at: key1) at: key2 put: OrderedCollection new].
		((result at: key1)at: key2) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 11/29/2010 10:11'!
buildByVersion
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| key value systemVersion |
		systemVersion := self findVersionOf: each.
		key := systemVersion version, ' - ',systemVersion highestUpdate asString..
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'private' stamp: ''!
byClassSelector

	^ #groupedByClass! !

!MessageList methodsFor: 'private' stamp: ''!
byDateAscendingSelector

	^ #groupedByDateAscending! !

!MessageList methodsFor: 'private' stamp: ''!
byDateDescendingSelector

	^ #groupedByDateDescending! !

!MessageList methodsFor: 'private' stamp: ''!
byPackageSelector

	^ #groupedByPackage! !

!MessageList methodsFor: 'private' stamp: ''!
byVersionSelector

	^ #groupedByVersion! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
checkCurrentHighestUpdate: aMethodReference

	| highestUpdate |
	highestUpdate := SystemVersion current highestUpdate.
	(self versionsHistoryList isEmpty or: [highestUpdate > self versionsHistoryList last key highestUpdate])
		ifTrue: [ 
			self addVersion: (Association key: SystemVersion current value: aMethodReference timeStamp)]! !

!MessageList methodsFor: 'actions' stamp: ''!
clearAll

	self methodReferenceList: OrderedCollection new.
	self updateView.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
dictionary
	dictionary ifNil: [self groupedByClass].
	^dictionary! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
dictionary: aDictionary

	dictionary := aDictionary! !

!MessageList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
environment

	^Smalltalk globals! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:45'!
findIndexOfVersionOf: aMethodReference

	| list timeStamp|
	timeStamp := aMethodReference timeStamp.
	list := self versionsHistoryList.
	list size == 1
		ifTrue: [^1].
	1 to: list size - 1 do: [:i || current next |
		current := list at: i.
		next := list at: (i+1).
		((current value <= timeStamp asDateAndTime) & (next value > timeStamp asDateAndTime))
			ifTrue: [^i]].
	^list size.! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
findVersionOf: aMethodReference

	| index |
	index := self findIndexOfVersionOf: aMethodReference.
	^(self versionsHistoryList at: index) key! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:32'!
groupedByClass
	"update the instance variable"
	
	self groupedByClassSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
groupedByClassSilently
	"update the instance variable"
	
	| association |
	association := self buildByClass.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byClassSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:10'!
groupedByDateAscending
	"update the instance variable"
	
	self groupedByDateAscendingSilently.
	self updateView.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
groupedByDateAscendingSilently
	"update the instance variable"
	
	| association |
	association := self buildByDate: [:m1 :m2 | m1 timeStamp <= m2 timeStamp].
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byDateAscendingSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:09'!
groupedByDateDescending
	"update the instance variable"
	
	self groupedByDateDescendingSilently.
	self updateView.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByDateDescendingSilently
	"update the instance variable"
	
	| association |
	association := self buildByDate: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byDateDescendingSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:09'!
groupedByPackage
	"update the instance variable"
	
	self groupedByPackageSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByPackageSilently
	"update the instance variable"
	
	| association |
	association := self buildByPackage.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byPackageSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:10'!
groupedByVersion
	"update the instance variable"
	
	self groupedByVersionSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByVersionSilently
	"update the instance variable"
	
	| association |
	association := self buildByVersion.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byVersionSelector.! !

!MessageList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2010 11:27'!
initialize 
	"Initialization"
	
	super initialize.
	useAsASet := false.
	methodReferenceList := OrderedCollection new.
	self clearAll.
	environment := self environment.
	versionsHistoryList := SortedCollection new sortBlock: [:a :b | a value < b value].
	self addFirstVersion.
	sortedMethodReferencesList := OrderedCollection new.! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByClass

	^ self  sortingSelector = self  byClassSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByDateAscending

	^self sortingSelector = self byDateAscendingSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByDateDescending

	^self sortingSelector = self byDateDescendingSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
isSortedByPackage

	^self sortingSelector = self byPackageSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
isSortedByVersion

	^self sortingSelector = self byVersionSelector
	! !

!MessageList methodsFor: 'accessing' stamp: ''!
lastEntry 

	^lastEntry! !

!MessageList methodsFor: 'accessing' stamp: ''!
level
		
	(self level2Selectors includes: (self sortingSelector))
		ifTrue: [^2].
	(self level3Selectors includes: (self sortingSelector))
		ifTrue: [^3].
	self error: 'The selector isn''t classified'! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
level2Selectors

	^#( #groupedByClass #groupedByVersion)! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
level3Selectors

	^#( #groupedByDateAscending #groupedByDateDescending #groupedByPackage).! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
methodReferenceList

	^ methodReferenceList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
methodReferenceList: anObject

	methodReferenceList := anObject! !

!MessageList methodsFor: 'ui opening' stamp: 'BenjaminVanRyseghem 11/29/2010 11:27'!
openInWorld
	"opens the system window for recent messages"

	| browser |
	browser := MessageListBrowser on: self.
	browser openInWorld.! !

!MessageList methodsFor: 'method version' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
priorVersionOfAMethod: aMethodReference

	| tempList |
	tempList := self methodReferenceList select:[:each | 
		(each classSymbol = aMethodReference classSymbol) & 
		(each methodSymbol = aMethodReference methodSymbol)].
	^ tempList detect: [:each | (self versionOfAMethod: each) = ((self versionOfAMethod: aMethodReference) -1)] ifNone: [aMethodReference].! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
reSort

	^ self perform: (self sortingSelector,'Silently') asSymbol! !

!MessageList methodsFor: 'actions' stamp: ''!
removeMethodReference: aMethodReference

	self methodReferenceList remove: aMethodReference.
	self updateView.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortedMethodReferencesList

	^sortedMethodReferencesList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortedMethodReferencesList: anObject

	sortedMethodReferencesList := anObject! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortingSelector

	sortingSelector ifNil: [^ #groupedByClass].
	^sortingSelector
	! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortingSelector: anObject

	sortingSelector := anObject.! !

!MessageList methodsFor: 'ui opening' stamp: 'BenjaminVanRyseghem 1/11/2011 14:06'!
title
	
	^'Message List'! !

!MessageList methodsFor: 'ui opening' stamp: 'BenjaminVanRyseghem 11/29/2010 10:56'!
updateView
	
	self changed: #sortingSelector.
	self changed: #sortedMethodReferencesList.
	self changed: #dictionary.
	self triggerEvent: #changed.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
useAsASet

	^ useAsASet! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
useAsASet: anObject

	useAsASet := anObject.
	anObject 
		ifTrue: [	self methodReferenceList: ((self methodReferenceList reversed asSet) asOrderedCollection)].
	self updateView! !

!MessageList methodsFor: 'method version' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
versionOfAMethod: aMethodReference

	| tempList |
	tempList := self methodReferenceList select: [:each | 
		(each classSymbol = aMethodReference classSymbol) & 
		(each methodSymbol = aMethodReference methodSymbol)].
	tempList := tempList sort: [:m1 :m2 | m1 timeStamp < m2 timeStamp].
	^ tempList indexOf: aMethodReference ifAbsent: [0]! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
versionsHistoryList

	^ versionsHistoryList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
versionsHistoryList: anObject

	versionsHistoryList := anObject! !

MessageList subclass: #RecentMessageList
	instanceVariableNames: 'maxListSize'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

RecentMessageList class
	instanceVariableNames: 'settingDropList'!

!RecentMessageList commentStamp: '<historical>' prior: 0!
RecentMessageList record and store all the changes and can show them by doing RecentMessageList openInWorld.!

RecentMessageList class
	instanceVariableNames: 'settingDropList'!

!RecentMessageList class methodsFor: 'events' stamp: ''!
classEvent: anEvent

	anEvent isAdded
		ifTrue: [ self uniqueInstance aClassHasBeenAdded: anEvent].
	anEvent isCommented
		ifTrue: [ self uniqueInstance aClassHasBeenCommented: anEvent].
	anEvent isModified
		ifTrue: [ self uniqueInstance aClassHasBeenModified: anEvent].
	anEvent isRecategorized
		ifTrue: [ self uniqueInstance aClassHasBeenRecategorized: anEvent].
	anEvent isRemoved
		ifTrue: [ self uniqueInstance aClassHasBeenRemoved: anEvent].
	anEvent isRenamed
		ifTrue: [ self uniqueInstance aClassHasBeenRenamed: anEvent].
	anEvent isReorganized
		ifTrue: [ self uniqueInstance aClassHasBeenReorganized: anEvent].! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
event: anEvent
	"Hook for SystemChangeNotifier"

	anEvent itemKind = SystemChangeNotifier classKind
		ifTrue:[ self classEvent: anEvent].
	anEvent itemKind = SystemChangeNotifier methodKind
		ifTrue:[ self methodEvent: anEvent].! !

!RecentMessageList class methodsFor: 'setting' stamp: 'StephaneDucasse 11/26/2010 17:04'!
icon

	^ThemeIcons smallInfoIcon! !

!RecentMessageList class methodsFor: 'initialize' stamp: ''!
initialize
	self startUp! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
methodEvent: anEvent

	anEvent isAdded
		ifTrue: [ self uniqueInstance aMethodHasBeenAdded: anEvent].
	anEvent isCommented
		ifTrue: [ self uniqueInstance aMethodHasBeenCommented: anEvent].
	anEvent isModified
		ifTrue: [ self uniqueInstance aMethodHasBeenModified: anEvent].
	anEvent isRecategorized
		ifTrue: [ self uniqueInstance aMethodHasBeenRecategorized: anEvent].
	anEvent isRemoved
		ifTrue: [ self uniqueInstance aMethodHasBeenRemoved: anEvent].
	anEvent isRenamed
		ifTrue: [ self uniqueInstance aMethodHasBeenRenamed: anEvent].
	anEvent isReorganized
		ifTrue: [ self uniqueInstance aMethodHasBeenReorganized: anEvent].! !

!RecentMessageList class methodsFor: 'instance creation' stamp: ''!
new
	^ self uniqueInstance! !

!RecentMessageList class methodsFor: 'ui opening facilities' stamp: ''!
openInWorld
	
	self uniqueInstance openInWorld.! !

!RecentMessageList class methodsFor: 'setting' stamp: 'StephaneDucasse 11/26/2010 17:04'!
recentMessageListMenuOn: aBuilder 
	<worldMenu> 
	
	(aBuilder item: #'Recent Messages')
		action: [self openInWorld];
		parent: #Tools;
		help: 'Browse the last messages you submit';
		icon: self icon;
		order: 1.! !

!RecentMessageList class methodsFor: 'setting' stamp: 'BenjaminVanRyseghem 12/16/2010 15:43'!
recentMessageListSettingOn: aBuilder 
	<systemsettings>

	(aBuilder group: #recentMessageList)
		target: self;
		parent: #codeBrowsing;
		label: 'Recent Messages' translated;
		description: 'Settings related to the recent messages browser' translated;
		with: [
			(aBuilder setting: #maxListSize)
				target: self uniqueInstance;
				label: 'Maximum size of the methods list' translated;
				description: 'If negative or zero, the size will be infinite. Caution : It may slow down your system' translated.
			(aBuilder setting: #useAsASet)
				target: self uniqueInstance;
				label: 'Use as a Set' translated;
				description: 'If true, then the list will act as a Set' translated.]! !

!RecentMessageList class methodsFor: 'instance creation' stamp: 'StephaneDucasse 11/26/2010 17:05'!
resetUniqueInstance
	"Reset the singleton of the recentMessageBrowser model, so if you execute it you will lose all the history of the recent messages."
	"self resetUniqueInstance"
	
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self uniqueInstance.
	self uniqueInstance triggerEvent: #reset.
	UniqueInstance := nil.
	! !

!RecentMessageList class methodsFor: 'system startup' stamp: ''!
startUp
	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:.! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
stopNotifications
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!RecentMessageList class methodsFor: 'instance creation' stamp: ''!
uniqueInstance

	UniqueInstance ifNil: [UniqueInstance := super new].
	^UniqueInstance! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenAdded: anEvent! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenCommented: anEvent

	anEvent newStamp notNil
		ifTrue:[self addMethodReference: (self createAClassReference: anEvent)]! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenModified: anEvent
! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenRecategorized: anEvent
! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aClassHasBeenRemoved: anEvent

	self removeAClass: anEvent! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aClassHasBeenRenamed: anEvent

	| toChangeList |
	toChangeList := self methodReferenceList select: [:each | each classSymbol = anEvent oldName asSymbol].
	toChangeList do: [:each | each classSymbol: anEvent newName asSymbol].
	self updateView.! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenReorganized: anEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aMethodHasBeenAdded: aMethodEvent

	self addMethodReference: (self createTheMethodReference: aMethodEvent)
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenCommented: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenModified: aMethodEvent

	self addMethodReference: (self createTheMethodReference: aMethodEvent)
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenRecategorized: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aMethodHasBeenRemoved: aMethodEvent

	self removeAMethod: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenRenamed: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenReorganized: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenhanged: aMethodEvent

! !

!RecentMessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:53'!
addMethodReference: aMethodReference.

	self addMethodReferenceSilently: aMethodReference.
	self checkSize.
	self updateView! !

!RecentMessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:57'!
checkSize

	| result |
	result := false.
	self maxListSize > 0 "0 means infinite"
		ifTrue: [
			result := (self methodReferenceList size > self maxListSize).
			[self methodReferenceList size > self maxListSize]
				whileTrue: [self methodReferenceList removeFirst]].
	^result! !

!RecentMessageList methodsFor: 'method reference creation' stamp: ''!
createAClassReference: aCommentedEvent

	^CommentReference class: aCommentedEvent item! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'StephaneDucasse 11/26/2010 17:03'!
createARemovalMethodReference: aRemovedEvent
	
	| method string methodReference |
	method := aRemovedEvent item.
	string := method methodClass name asString, ' >> #', method selector.
	^ SourcedMethodReference
		setClass: method methodClass 
		methodSymbol: method selector! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'StephaneDucasse 11/26/2010 17:03'!
createTheMethodReference: aModifiedMethodEvent
	
	| method string |
	method := aModifiedMethodEvent item.
	string := method methodClass name asString, ' >> #', method selector.
	^ SourcedMethodReference
		class: method methodClass
		selector: method selector! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
defaultMaxListSize

	^100! !

!RecentMessageList methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
initialize

	super initialize.
	
	Smalltalk addToStartUpList: self class.! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
maxListSize

	maxListSize ifNil: [maxListSize := self defaultMaxListSize].
	^maxListSize! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:55'!
maxListSize: aNumber

	maxListSize := (aNumber negative 
						ifTrue: [0]
						ifFalse:[aNumber]).
	self checkSize
		ifTrue: [self updateView]! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 11/26/2010 17:03'!
removeAClass: anEvent
	
	| tempList |
	tempList := self methodReferenceList select:[:each | each classSymbol = anEvent item name asSymbol].
	tempList do: [:each | self removeMethodReference: each]! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 11/26/2010 17:02'!
removeAMethod: aRemovedEvent
	
	| method string newString list |
	method := aRemovedEvent item.
	string := method methodClass name asString, ' >> #', method selector.
	newString := method methodClass name asString, '(removed) >> #', method selector.
	list := (self methodReferenceList select: [:each | each stringVersion = string]).
	list do: [:each | 
			each methodSymbol: (each methodSymbol, ' (removed)').
			each stringVersion: newString.].
	self updateView.
	
	! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 11/26/2010 17:03'!
stringMethodRemoved

	^'This method have been removed'
	! !

!RecentMessageList methodsFor: 'ui opening' stamp: 'BenjaminVanRyseghem 1/11/2011 14:07'!
title

	^'Recent Message List'! !

MessageList subclass: #Senders
	instanceVariableNames: ''
	classVariableNames: 'selector'
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

!Senders class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 1/11/2011 16:10'!
allSendersOf: selector

	^self new 
		selector: selector! !

!Senders methodsFor: 'selection' stamp: 'BenjaminVanRyseghem 1/11/2011 16:46'!
autoSelectionInterval: aText

	| list firstSearchingString lastSearchingString firstLineIndex firstIndex lastIndex |
	list := self selector subStrings: ':'.
	firstSearchingString := list first, ':'.
	lastSearchingString := list last, ':'.
	
	(aText includesSubString: firstSearchingString) ifFalse: [^ super autoSelectionInterval: aText].
	
	firstLineIndex := aText indexOf: Character cr.
	firstIndex := aText findString: firstSearchingString startingAt: firstLineIndex.
	lastIndex := (aText findString: lastSearchingString startingAt: firstIndex) + lastSearchingString size - 1.
	^ firstIndex to: lastIndex! !

!Senders methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 1/11/2011 16:03'!
buildByClass
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m1 printString <= m2 printString].
	tempList do: [:each |
		| key value |
		key := each actualClass.
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!Senders methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/11/2011 16:09'!
selector

	^selector! !

!Senders methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/11/2011 16:55'!
selector: aSelector

	selector := aSelector.
	self methodReferenceList: (SystemNavigation default allCallsOn: selector)! !

!Senders methodsFor: 'ui opening' stamp: 'BenjaminVanRyseghem 1/11/2011 16:17'!
title

	| stream |
	stream := WriteStream with: ''.
	stream 
		nextPutAll: 'Senders of ';
		nextPutAll: self selector asString;
		nextPut: Character space ;
		nextPut: $[;
		nextPutAll: self methodReferenceList size asString;
		nextPut: $].
	^stream contents! !
RecentMessageList initialize!
